//+------------------------------------------------------------------+
//|                                            Vova-x@list.ru    mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double volume=0.1;//
extern double volume_multiplier=2;// 
extern double mnozhitel_prirosta_urovney=1;
extern int level_up=70; //    
extern int level_dn=70; //    
extern int chislo_popitok=5; // 
extern int slippage=100; //   
extern int stoploss_=45; //  
extern int takeprofit_=9999; //  
extern int expiration_in_seconds=15000; //      
extern int magic=50;//  ,    
extern int start_trailing_level=20; //       ,      ,        
extern int trailing=20;//  
extern bool stop_orders=true;//    -      ,   ,        
extern bool Bollinger_Bands=false;//   ,         ,   ,    
extern int period=20;//    
extern int deviation=2;//    
extern int bands_shift=0;//    

   int aBuyCount=0;
   int aSellCount=0;
   int aBuyCount1=0;
   int aSellCount1=0;

int start_time;
double begin_price;
double max_lot,min_lot;
double spread;
int vol_dig;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
start_time=TimeCurrent();


if(MarketInfo(Symbol(),MODE_LOTSTEP)==1)vol_dig=0;
if(MarketInfo(Symbol(),MODE_LOTSTEP)==0.1)vol_dig=1;
if(MarketInfo(Symbol(),MODE_LOTSTEP)==0.01)vol_dig=2;
max_lot=MarketInfo(Symbol(),MODE_MAXLOT);
min_lot=MarketInfo(Symbol(),MODE_MINLOT);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   history_deals();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int number,number_buy=1,number_sell=1;
int start()
  {
//----
if(IsTesting())ObjectsDeleteAll(0,-1);
orders();
begin_price=Bid;
//////////////////////////
number_buy=1;number_sell=1;
for(int i=OrdersHistoryTotal()-1;i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
number=StrToDouble(OrderComment());
if(OrderType()==OP_BUY&&number_buy==1){
if(OrderOpenTime()<start_time)break;
if(NormalizeDouble(OrderOpenPrice()-stoploss_*Point,Digits)<OrderStopLoss()){number_buy=1000000;}
if(NormalizeDouble(OrderOpenPrice()-stoploss_*Point,Digits)==OrderStopLoss()){number_buy=number+1;}
}//if(OrderType()==OP_BUY){
if(OrderType()==OP_SELL&&number_sell==1){
if(OrderOpenTime()<start_time)break;
if(NormalizeDouble(OrderOpenPrice()+stoploss_*Point,Digits)>OrderStopLoss()){number_sell=1000000;}
if(NormalizeDouble(OrderOpenPrice()+stoploss_*Point,Digits)==OrderStopLoss()){number_sell=number+1;}
}//if(OrderType()==OP_BUY){
}//if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic_N){
}//for(int i=OrdersHistoryTotal()-1;i>=0;i--){
//////////////////////////


spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
double level_dn_;
double level_up_;


double vol;
int stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
datetime expiration=0;
bool trade=true;
if(number_sell>=chislo_popitok)number_sell=1;
if(number_buy>=chislo_popitok)number_buy=1;

double m=MathPow(mnozhitel_prirosta_urovney,MathMax(number_buy,number_sell)-1);
if(stop_orders){
 level_dn_=begin_price-level_dn*Point*m;
 level_up_=begin_price+level_up*Point*m+spread;
 }
if(!stop_orders){
 level_dn_=begin_price-level_dn*Point*m+spread;
 level_up_=begin_price+level_up*Point*m;
 }

//if(number_sell==1&&number_buy==1&&TimeCurrent()>start_time+expiration_in_seconds)trade=false;
if(!Bollinger_Bands&&trade){
if(level_dn_<Bid-stoplevel*Point&&aSellCount1==0){
vol=MathMin(MathMax(NormalizeDouble(MathPow(volume_multiplier,MathMax(number_buy,number_sell))*volume/volume_multiplier,vol_dig),min_lot),max_lot);
if(stop_orders)OrderSend(Symbol(),OP_SELLSTOP,vol,NormalizeDouble(level_dn_,Digits),slippage,
NormalizeDouble(level_dn_+stoploss_*Point,Digits),NormalizeDouble(level_dn_-takeprofit_*Point,Digits),
DoubleToStr(number_sell,0),magic,expiration,CLR_NONE);
}
if(level_up_>Ask+stoplevel*Point&&aBuyCount1==0){
vol=MathMin(MathMax(NormalizeDouble(MathPow(volume_multiplier,MathMax(number_buy,number_sell))*volume/volume_multiplier,vol_dig),min_lot),max_lot);
if(stop_orders)OrderSend(Symbol(),OP_BUYSTOP,vol,NormalizeDouble(level_up_,Digits),slippage,
NormalizeDouble(level_up_-stoploss_*Point,Digits),NormalizeDouble(level_up_+takeprofit_*Point,Digits),
DoubleToStr(number_buy,0),magic,expiration,CLR_NONE);
}


if(level_dn_<Ask-stoplevel*Point&&aBuyCount1==0){
vol=MathMin(MathMax(NormalizeDouble(MathPow(volume_multiplier,number_buy)*volume/volume_multiplier,vol_dig),min_lot),max_lot);
if(!stop_orders)OrderSend(Symbol(),OP_BUYLIMIT,vol,NormalizeDouble(level_dn_,Digits),slippage,
NormalizeDouble(level_dn_-stoploss_*Point,Digits),NormalizeDouble(level_dn_+takeprofit_*Point,Digits),
DoubleToStr(number_buy,0),magic,expiration,CLR_NONE);
}
if(level_up_>Bid+stoplevel*Point&&aSellCount1==0){
vol=MathMin(MathMax(NormalizeDouble(MathPow(volume_multiplier,number_sell)*volume/volume_multiplier,vol_dig),min_lot),max_lot);
if(!stop_orders)OrderSend(Symbol(),OP_SELLLIMIT,vol,NormalizeDouble(level_up_,Digits),slippage,
NormalizeDouble(level_up_+stoploss_*Point,Digits),NormalizeDouble(level_up_-takeprofit_*Point,Digits),
DoubleToStr(number_sell,0),magic,expiration,CLR_NONE);
}


}//if(!Bolinger_Bands){


int applied_price=4;
if(Bollinger_Bands){
double bands_up_1=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_UPPER,1);
double bands_up_2=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_UPPER,2);
double bands_dn_1=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_LOWER,1);
double bands_dn_2=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_LOWER,2);
if(aSellCount1==0) //  
if(iLow(Symbol(),0,1)<bands_dn_1&&iLow(Symbol(),0,2)>bands_dn_2){

vol=MathMin(MathMax(NormalizeDouble(MathPow(volume_multiplier,number_sell)*volume/volume_multiplier,vol_dig),min_lot),max_lot);

OrderSend(Symbol(),OP_SELL,vol,NormalizeDouble(Ask,Digits),slippage,
0,NormalizeDouble(Bid-takeprofit_*Point,Digits),
DoubleToStr(number_sell,0),magic,expiration,CLR_NONE);
}//if(iHigh(Symbol(),0,1)>bands_up_1&&iHigh(Symbol(),0,2)<bands_up_2){
if(aBuyCount1==0)//
if(iHigh(Symbol(),0,1)>bands_up_1&&iHigh(Symbol(),0,2)<bands_up_2){
vol=MathMin(MathMax(NormalizeDouble(MathPow(volume_multiplier,number_buy)*volume/volume_multiplier,vol_dig),min_lot),max_lot);

OrderSend(Symbol(),OP_BUY,vol,NormalizeDouble(Bid,Digits),slippage,
0,NormalizeDouble(Ask+takeprofit_*Point,Digits),
DoubleToStr(number_buy,0),magic,expiration,CLR_NONE);
}//if(iLow(Symbol(),0,1)<bands_dn_1&&iLow(Symbol(),0,2)>bands_dn_2){
}//if(Bollinger_Bands){

if(aSellCount1+aBuyCount1>0)modify();
show();
//----
   return(0);
  }
//+------------------------------------------------------------------+

void modify(){
for(int i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
int number=StrToDouble(OrderComment());

int count,bar;
double m;
double stoploss;
if(OrderType()==OP_BUY){
count=iBarShift(Symbol(),1,OrderOpenTime(),false);
bar=iHighest(Symbol(),1,MODE_HIGH,count-1,0);
if(count>0&&bar>0){
m=iHigh(Symbol(),1,bar);
stoploss=m-trailing*Point;
if(m>OrderOpenPrice()-MarketInfo(Symbol(),MODE_SPREAD)*Point+start_trailing_level*Point)
if(stoploss>OrderStopLoss())if(stoploss<MarketInfo(Symbol(),MODE_BID)-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
if(!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(stoploss,Digits),OrderTakeProfit(),OrderExpiration(),CLR_NONE))
Print("BUY "+OrderOpenPrice()+" "+stoploss);
}//if(bar>0){
if(OrderStopLoss()==0)OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-stoploss_*Point,Digits),OrderTakeProfit(),OrderExpiration(),CLR_NONE);
}//if(OrderType()==OP_BUY){
if(OrderType()==OP_SELL){
count=iBarShift(Symbol(),1,OrderOpenTime(),false);
bar=iLowest(Symbol(),1,MODE_LOW,count-1,0);
if(count>0&&bar>0){
m=iLow(Symbol(),1,bar);
stoploss=m+(trailing+MarketInfo(Symbol(),MODE_SPREAD))*Point;
if(m<OrderOpenPrice()-start_trailing_level*Point)
if(stoploss<OrderStopLoss())
if(stoploss>MarketInfo(Symbol(),MODE_ASK)+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
if(!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(stoploss,Digits),OrderTakeProfit(),OrderExpiration(),CLR_NONE))
Print("SELL "+OrderOpenPrice()+" "+stoploss);
}//if(bar>0){
if(OrderStopLoss()==0)OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+stoploss_*Point,Digits),OrderTakeProfit(),OrderExpiration(),CLR_NONE);
}//if(OrderType()==OP_BUY){
if(OrderType()>2&&TimeCurrent()>OrderOpenTime()+expiration_in_seconds)OrderDelete(OrderTicket());
}//if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic_N){
}//for(int i=0;i<OrdersTotal();i++){
}//void modify(int strategy){


void orders(){
RefreshRates();
    aBuyCount=0;  
    aSellCount=0;
    aBuyCount1=0;  
    aSellCount1=0;
    int number=0;
     int cmd;
     bool ticket=true;
      for(int i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
           cmd=OrderType();
           number=StrToDouble(OrderComment());
                  if(cmd==OP_BUY||cmd==OP_BUYSTOP||cmd==OP_BUYLIMIT){aBuyCount++;}
                  if(cmd==OP_SELL||cmd==OP_SELLSTOP||cmd==OP_SELLLIMIT){aSellCount++;}  
            if(number>0){     
                  if(cmd==OP_BUY||cmd==OP_BUYSTOP||cmd==OP_BUYLIMIT){aBuyCount1++;}
                  if(cmd==OP_SELL||cmd==OP_SELLSTOP||cmd==OP_SELLLIMIT){aSellCount1++;}       
                        }
         }//if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic_N){
         }//for(int i=0;i<OrdersTotal();i++){

}



 void show(){
string stroka="";
string cmd;
string shapka="                                                                              "+
             "\n                                                 ";
for(int i=0;i<OrdersTotal();i++){
OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
if(OrderType()==OP_BUY)cmd="OP_BUY         ";if(OrderType()==OP_SELL)cmd="OP_SELL        ";
if(OrderType()==OP_BUYSTOP)cmd="OP_BUYSTOP";if(OrderType()==OP_SELLSTOP)cmd="OP_SELLSTOP";
if(OrderType()==OP_BUYLIMIT)cmd="OP_BUYLIMIT";if(OrderType()==OP_SELLLIMIT)cmd="OP_SELLLIMIT";
stroka=stroka+"\n                             "+cmd
+" "+DoubleToStr(OrderLots(),2)
+"    "+TimeToStr(OrderOpenTime(),TIME_DATE|TIME_SECONDS)
+"    "+DoubleToStr(OrderOpenPrice(),Digits)
+"    "+DoubleToStr(OrderStopLoss(),Digits)
+"           "+DoubleToStr(OrderTakeProfit(),Digits)
+"         "+OrderComment()
+"         "+TimeToStr(OrderExpiration())
+"\n"

;}
Comment(shapka+
//aBuyStopCount+" "+aSellLimitCount+" "+aSellStopCount+" "+aBuyLimitCount+" "+max+" "+min+" "+Ask_+" "+Bid_+"\n"+
stroka+"\n"+
"STOPLEVEL = "+MarketInfo(Symbol(),MODE_STOPLEVEL)+"\n"+
"FREEZELEVEL = "+MarketInfo(Symbol(),MODE_FREEZELEVEL)+"\n"
+number_buy+" "+number_sell
);
}




void history_deals(){
ObjectsDeleteAll(0,EMPTY);
  Print("OrdersHistoryTotal = "+OrdersHistoryTotal());
for(int i=0;i<OrdersHistoryTotal();i++){
OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
if(OrderSymbol()==Symbol()
&&OrderLots()>0.00
&&OrderProfit()!=0
){
string name="order"+i;
//Print(i);
double open_price,close_price;
if(OrderType()==OP_BUY){name=name+" buy";open_price=OrderOpenPrice();close_price=OrderClosePrice();}
if(OrderType()==OP_SELL){name=name+" sell";open_price=OrderOpenPrice();close_price=OrderClosePrice()-(Ask-Bid);}
name=name+" "+DoubleToStr(OrderLots(),2);

int width=MathPow(OrderLots(),0.6)*10;
width=1;
width=MathMax(width,1);
string name_="";
int j;
for( j=0;j<width;j++){
if(OrderLots()>0.00){
name_=OrderTicket()+" "+name+" "+j;
double sdvig=0;
if(OrderType()==OP_BUY)sdvig=Ask-Bid;
if(OrderType()==OP_SELL)sdvig=-(Ask-Bid);
ObjectCreate(name_,OBJ_TREND,0,OrderOpenTime(),open_price+j*Point/5,OrderCloseTime(),close_price+j*Point/5+sdvig);
ObjectSet(name_,OBJPROP_RAY,false);
if(OrderType()==OP_BUY)ObjectSet(name_,OBJPROP_COLOR,Blue);
if(OrderType()==OP_SELL)ObjectSet(name_,OBJPROP_COLOR,Red);
//if(OrderLots()<0.02)ObjectSet(name_,OBJPROP_COLOR,Gray);
}
}
}
}
}